# The syntax setting a default image / script is not supported by `gitlab-runner exec` see:
# https://gitlab.com/gitlab-org/gitlab-runner/-/issues/4604

# I wanted to have separate build/test steps, but for the test to
# use the output of the build rather than repeating all the steps.
# * I couldn't move rosinstall/rosdep setup to default script, because
#   that doesn't work with gitlab-runner.
# * I tried using artifacts/dependencies, but couldn't get it work in either.
# * I could get volumes to work, but only on my local machine.
#
# So, since an elegant solution was taking too long, I just put both
# building and testing in the same stage.

stages:
  - build
  - test

variables:
  ROS_WS: "/ci_ws"
  PROJECT_NAME: "bsee_i2c_sensor_driver"

pre-commit-hooks:
  stage: build
  image: lindzey/mcneil_remus_gitlab_ci
  script:
    - pre-commit install
    - pre-commit run --all-files

catkin-build-test:
  stage: test
  image: lindzey/mcneil_remus_gitlab_ci
  script:
    # \todo{aaron} I should bake these into a new CI image, but for the short term,
    # just install them manually...
    #
    - pip3 install Adafruit-blinka adafruit-circuitpython-bme280 adafruit-circuitpython-ina260
    # Boiler-plate for *this* project, setting up dependencies
    #
    # This is the type of stuff that belongs in a script...where args should be:
    # * name of rosinstall.repos file (b/c some packages may have more than one!)
    # * project name (b/c I can't figure out how to get gitlab-runner to tell it to me. the code just goes into a `project-0` directory.)
    - mkdir -p ${ROS_WS}/src
    - ln -s ${CI_PROJECT_DIR} ${ROS_WS}/src/${PROJECT_NAME}
    - echo "Installing dependencies from .repos!"
    - cd ${ROS_WS}/src
    - vcs import --input=${PROJECT_NAME}/${PROJECT_NAME}.repos .
    - cd ${ROS_WS}
    - rosdep install --from-paths src --ignore-src --rosdistro ${ROS_DISTRO} -y --as-root apt:false

    # build the workspace
    - cd ${ROS_WS}
    - pwd
    - catkin build

    # Run unit tests
    - source ${ROS_WS}/devel/setup.bash
    - catkin test ${PROJECT_NAME}

    # Check coverate of unit tests
    # - pip install pytest pytest-cov
    # - pytest --cov=${ROS_WS}/src/${PROJECT_NAME} --cov-report term --cov-report xml:coverage.xml
    # In order to be properly uploaded, the artifact needs to be in the expected build directory, not the catkin_ws we created
    # However, this will fail in gitlab-runner, so don't let it fail the pipeline.
    # - cp coverage.xml /builds/apl-ocean-engineering/mcneil-auv-lab/prooceanus_gtd_driver/ || true

    # I really want to figure out how to get build artifacts carried over,
    # so I can split this out into independent tests.
    # - python3 -m pip install mypy
    # - pip install types-pyserial
    # - pip install --extra-index-url https://rospypi.github.io/simple ros-stubs-all
    # - mypy src/${PROJECT_NAME}/src --strict

  # coverage: '/(?i)total.*? (100(?:\.0+)?\%|[1-9]?\d(?:\.\d+)?\%)$/'
  # artifacts:
  #   reports:
  #     coverage_report:
  #       coverage_format: cobertura
  #       path: coverage.xml
